## lilv 0.4.2

=== wscript ===
#!/usr/bin/env python
import os
import sys
import subprocess

from waflib.extras import autowaf as autowaf
import waflib.Options as Options
import waflib.Logs as Logs

# Version of this package (even if built as a child)
LILV_VERSION       = '0.4.2'
LILV_MAJOR_VERSION = '0'

# Library version (UNIX style major, minor, micro)
# major increment <=> incompatible changes
# minor increment <=> compatible changes (additions)
# micro increment <=> no interface changes
# Lilv uses the same version number for both library and package
LILV_LIB_VERSION = LILV_VERSION

# Variables for 'waf dist'
APPNAME = 'lilv'
VERSION = LILV_VERSION

# Mandatory variables
top = '.'
out = 'build'

def options(opt):
    autowaf.set_options(opt)
    opt.load('python')
    opt.add_option('--no-utils', action='store_true', default=False, dest='no_utils',
                   help="Do not build command line utilities")
    opt.add_option('--no-jack', action='store_true', default=False, dest='no_jack',
                   help="Do not build JACK clients")
    opt.add_option('--no-jack-session', action='store_true', default=False,
                   dest='no_jack_session',
                   help="Do not build JACK session support")
    opt.add_option('--bindings', action='store_true', default=False, dest='bindings',
                   help="Build python bindings")
    opt.add_option('--dyn-manifest', action='store_true', default=False,
                   dest='dyn_manifest',
                   help="Build support for dynamic manifests")
    opt.add_option('--test', action='store_true', default=False, dest='build_tests',
                   help="Build unit tests")
    opt.add_option('--no-bash-completion', action='store_true', default=False,
                   dest='no_bash_completion',
                   help="Install bash completion script in /etc/bash_completion.d")
    opt.add_option('--default-lv2-path', type='string', default='',
                   dest='default_lv2_path',
                   help="Default LV2 path to use if $LV2_PATH is unset (globs and ~ supported)")

def configure(conf):
    conf.line_just = 63
    autowaf.configure(conf)
    autowaf.display_header('Lilv Configuration')
    conf.load('compiler_cc')
    conf.load('python')

    if Options.options.bindings:
        try:
            conf.load('swig python')
            conf.check_python_headers()
            autowaf.define(conf, 'LILV_BINDINGS', 1);
        except:
            pass

    autowaf.check_pkg(conf, 'lv2core', uselib_store='LV2CORE', mandatory=True)
    autowaf.check_pkg(conf, 'glib-2.0', uselib_store='GLIB',
                      atleast_version='2.0.0', mandatory=True)
    autowaf.check_pkg(conf, 'gthread-2.0', uselib_store='GTHREAD',
                      atleast_version='2.0.0', mandatory=False)
    autowaf.check_pkg(conf, 'sord-0', uselib_store='SORD',
                      atleast_version='0.4.0', mandatory=True)
    autowaf.check_pkg(conf, 'jack', uselib_store='JACK',
                      atleast_version='0.107.0', mandatory=False)
    autowaf.check_pkg(conf, 'jack', uselib_store='NEW_JACK',
                      atleast_version='0.120.0', mandatory=False)

    conf.check(function_name='wordexp',
               header_name='wordexp.h',
               define_name='HAVE_WORDEXP',
               mandatory=False)

    autowaf.check_header(conf, 'lv2/lv2plug.in/ns/lv2core/lv2.h')

    if not Options.options.no_jack_session:
        if conf.is_defined('HAVE_NEW_JACK') and conf.is_defined('HAVE_GTHREAD'):
            autowaf.define(conf, 'LILV_JACK_SESSION', 1)

    conf.env.append_value('CFLAGS', '-std=c99')
    autowaf.define(conf, 'LILV_VERSION', LILV_VERSION)
    if Options.options.dyn_manifest:
        autowaf.define(conf, 'LILV_DYN_MANIFEST', 1)

    lilv_path_sep = ':'
    lilv_dir_sep  = '/'
    if sys.platform == 'win32':
        lilv_path_sep = ';'
        lilv_dir_sep = '\\\\'

    autowaf.define(conf, 'LILV_PATH_SEP', lilv_path_sep)
    autowaf.define(conf, 'LILV_DIR_SEP',  lilv_dir_sep)

    if Options.options.default_lv2_path == '':
        if Options.platform == 'darwin':
            Options.options.default_lv2_path = lilv_path_sep.join([
                    '~/Library/Audio/Plug-Ins/LV2',
                    '~/.lv2',
                    '/usr/local/lib/lv2',
                    '/usr/lib/lv2',
                    '/Library/Audio/Plug-Ins/LV2'])
        elif Options.platform == 'haiku':
            Options.options.default_lv2_path = lilv_path_sep.join([
                    '~/.lv2',
                    '/boot/common/add-ons/lv2'])
        elif Options.platform == 'win32':
            Options.options.default_lv2_path = '%APPDATA%\\\\LV2;%PROGRAMFILES%\\\\LV2'
        else:
            libdirname = os.path.basename(conf.env['LIBDIR'])
            Options.options.default_lv2_path = lilv_path_sep.join([
                    '~/.lv2',
                    '/usr/%s/lv2' % libdirname,
                    '/usr/local/%s/lv2' % libdirname])

    autowaf.define(conf, 'LILV_DEFAULT_LV2_PATH', Options.options.default_lv2_path)

    conf.env['BUILD_TESTS']     = Options.options.build_tests
    conf.env['BUILD_UTILS']     = not Options.options.no_utils
    conf.env['BASH_COMPLETION'] = not Options.options.no_bash_completion

    conf.env['LIB_LILV'] = ['lilv-%s' % LILV_MAJOR_VERSION]

    if conf.is_defined('HAVE_JACK') and not Options.options.no_jack:
        autowaf.check_header(conf, 'lv2/lv2plug.in/ns/ext/event/event.h',
                             'HAVE_LV2_EVENT', mandatory=False)
        autowaf.check_header(conf, 'lv2/lv2plug.in/ns/ext/event/event-helpers.h',
                             'HAVE_LV2_EVENT_HELPERS', mandatory=False)
        autowaf.check_header(conf, 'lv2/lv2plug.in/ns/ext/uri-map/uri-map.h',
                             'HAVE_LV2_URI_MAP', mandatory=False)
        if (conf.is_defined('HAVE_LV2_EVENT')
            and conf.is_defined('HAVE_LV2_EVENT_HELPERS')
            and conf.is_defined('HAVE_LV2_URI_MAP')):
            autowaf.define(conf, 'LILV_USE_JACK', 1)

    conf.write_config_header('lilv-config.h', remove=False)

    autowaf.display_msg(conf, "Default LV2_PATH",
                        conf.env['LILV_DEFAULT_LV2_PATH'])
    autowaf.display_msg(conf, "Utilities",
                        bool(conf.env['BUILD_UTILS']))
    autowaf.display_msg(conf, "Jack clients",
                        bool(conf.is_defined('LILV_USE_JACK')))
    autowaf.display_msg(conf, "Jack session support",
                        bool(conf.env['LILV_JACK_SESSION']))
    autowaf.display_msg(conf, "Unit tests",
                        bool(conf.env['BUILD_TESTS']))
    autowaf.display_msg(conf, "Dynamic manifest support",
                        bool(conf.env['LILV_DYN_MANIFEST']))
    autowaf.display_msg(conf, "Python bindings",
                        conf.is_defined('LILV_PYTHON'))
    print('')

def build(bld):
    # C/C++ Headers
    includedir = '${INCLUDEDIR}/lilv-%s/lilv' % LILV_MAJOR_VERSION
    bld.install_files(includedir, bld.path.ant_glob('lilv/*.h'))
    bld.install_files(includedir, bld.path.ant_glob('lilv/*.hpp'))

    # Pkgconfig file
    autowaf.build_pc(bld, 'LILV', LILV_VERSION, LILV_MAJOR_VERSION, [],
                     {'LILV_MAJOR_VERSION' : LILV_MAJOR_VERSION})

    lib_source = '''
        src/collections.c
        src/instance.c
        src/node.c
        src/plugin.c
        src/pluginclass.c
        src/port.c
        src/query.c
        src/scalepoint.c
        src/ui.c
        src/util.c
        src/world.c
    '''.split()

    linkflags = [ '-ldl' ]
    libflags  = [ '-fvisibility=hidden' ]
    if sys.platform == 'win32':
        linkflags = []
        libflags  = []

    # Library
    obj = bld(features        = 'c cshlib',
              export_includes = ['.'],
              source          = lib_source,
              includes        = ['.', './src'],
              name            = 'liblilv',
              target          = 'lilv-%s' % LILV_MAJOR_VERSION,
              vnum            = LILV_LIB_VERSION,
              install_path    = '${LIBDIR}',
              cflags          = libflags + [
                                  '-DLILV_SHARED',
                                  '-DLILV_INTERNAL' ],
              linkflags       = linkflags)
    autowaf.use_lib(bld, obj, 'SORD SERD LV2CORE GLIB')

    if bld.env['BUILD_TESTS']:
        # Static library (for unit test code coverage)
        obj = bld(features     = 'c cstlib',
                  source       = lib_source,
                  includes     = ['.', './src'],
                  name         = 'liblilv_static',
                  target       = 'lilv_static',
                  install_path = '',
                  cflags       = [ '-fprofile-arcs',  '-ftest-coverage', '-DLILV_INTERNAL' ],
                  linkflags    = linkflags)
        autowaf.use_lib(bld, obj, 'SORD SERD LV2CORE GLIB')

        # Unit test program
        obj = bld(features     = 'c cprogram',
                  source       = 'test/lilv_test.c',
                  includes     = ['.', './src'],
                  use          = 'liblilv_static',
                  uselib       = 'SORD SERD LV2CORE',
                  linkflags    = linkflags + ['-lgcov'],
                  target       = 'test/lilv_test',
                  install_path = '',
                  cflags       = [ '-fprofile-arcs',  '-ftest-coverage' ])

    # Utilities
    if bld.env['BUILD_UTILS']:
        utils = '''
            utils/lv2info
            utils/lv2ls
            utils/lilv-bench
        '''
        for i in utils.split():
            obj = bld(features     = 'c cprogram',
                      source       = i + '.c',
                      includes     = ['.', './src', './utils'],
                      use          = 'liblilv',
                      target       = i,
                      install_path = '${BINDIR}')

    # JACK Host
    if bld.is_defined('LILV_USE_JACK'):
        obj = bld(features     = 'c cprogram',
                  source       = 'utils/lv2jack.c',
                  includes     = ['.', './src', './utils'],
                  uselib       = 'JACK',
                  use          = 'liblilv',
                  target       = 'utils/lv2jack',
                  install_path = '${BINDIR}')
        if bld.is_defined('LILV_JACK_SESSION'):
            autowaf.use_lib(bld, obj, 'GLIB GTHREAD')

    # Documentation
    autowaf.build_dox(bld, 'LILV', LILV_VERSION, top, out)

    # Man pages
    bld.install_files('${MANDIR}/man1', bld.path.ant_glob('doc/*.1'))

    # Bash completion
    if bld.env['BASH_COMPLETION']:
        bld.install_as(
            '/etc/bash_completion.d/lilv', 'utils/lilv.bash_completion')

    if bld.is_defined('LILV_PYTHON'):
        # Python Wrapper
        obj = bld(features   = 'cxx cxxshlib pyext',
                  source     = 'bindings/lilv.i',
                  target     = 'bindings/_lilv',
                  includes   = ['..'],
                  swig_flags = '-c++ -python -Wall -I.. -llilv -features autodoc=1',
                  vnum       = LILV_LIB_VERSION,
                  use        = 'liblilv')
        autowaf.use_lib(bld, obj, 'LILV')

        bld.install_files('${PYTHONDIR}', 'bindings/lilv.py')

    bld.add_post_fun(autowaf.run_ldconfig)
    if bld.env['DOCS']:
        bld.add_post_fun(fix_docs)

def build_dir(ctx, subdir):
    if autowaf.is_child():
        return os.path.join('build', APPNAME, subdir)
    else:
        return os.path.join('build', subdir)

def fix_docs(ctx):
    try:
        top = os.getcwd()
        os.chdir(build_dir(ctx, 'doc/html'))
        os.system("sed -i 's/LILV_API //' group__lilv.html")
        os.system("sed -i 's/LILV_DEPRECATED //' group__lilv.html")
        os.remove('index.html')
        os.symlink('group__lilv.html',
                   'index.html')
        os.chdir(top)
        os.chdir(build_dir(ctx, 'doc/man/man3'))
        os.system("sed -i 's/LILV_API //' lilv.3")
        os.chdir(top)

=== debian/changelog ===
lilv (0.4.2-2) unstable; urgency=low

  * Improve description.
  * Fix a tiny bug preventing Lilv from properly working with dyn-manifest.

 -- Alessio Treglia <alessio@debian.org>  Sun, 29 May 2011 21:36:23 +0200

lilv (0.4.2-1) unstable; urgency=low

  * Initial release (Closes: #625791).

 -- Alessio Treglia <alessio@debian.org>  Fri, 27 May 2011 12:40:02 +0200

=== debian/control ===
Source: lilv
Section: libs
Priority: optional
Maintainer: Debian Multimedia Maintainers <pkg-multimedia-maintainers@lists.alioth.debian.org>
Uploaders: Alessio Treglia <alessio@debian.org>
Build-Depends: debhelper (>= 7.0.50~),
 libglib2.0-dev,
 libjack-dev,
 libsord-dev,
 lv2core,
 lv2-extensions-good,
 pkg-config,
 python-all-dev (>= 2.6.6-3),
 swig
Build-Depends-Indep: doxygen,
 graphviz
X-Python-Version: >= 2.6
Standards-Version: 3.9.2
Homepage: http://drobilla.net/software/lilv/
Vcs-Git: git://git.debian.org/git/pkg-multimedia/lilv.git
Vcs-Browser: http://git.debian.org/?p=pkg-multimedia/lilv.git

Package: liblilv-0-0
Architecture: any
Depends: ${shlibs:Depends},
 ${misc:Depends}
Description: library for simple use of LV2 plugins
 Lilv (formerly SLV2) is a library for LV2 hosts intended to make using
 LV2 Plugins as simple as possible (without sacrificing capabilities).
 .
 Lilv is the successor to SLV2, rewritten to be significantly faster
 and have minimal dependencies.
 .
 This package provides the shared library.

Package: python-lilv
Section: python
Architecture: any
Depends: ${shlibs:Depends},
 ${python:Depends},
 ${misc:Depends}
Description: library for simple use of LV2 plugins (Python bindings)
 Lilv (formerly SLV2) is a library for LV2 hosts intended to make using
 LV2 Plugins as simple as possible (without sacrificing capabilities).
 .
 Lilv is the successor to SLV2, rewritten to be significantly faster
 and have minimal dependencies.
 .
 This package provides the Python bindings.

Package: liblilv-dev
Section: libdevel
Architecture: all
Depends: liblilv-0-0 (>= ${source:Version}),
 liblilv-0-0 (<< ${source:Upstream-Version}+1~),
 ${misc:Depends}
Description: library for simple use of LV2 plugins (development files)
 Lilv (formerly SLV2) is a library for LV2 hosts intended to make using
 LV2 Plugins as simple as possible (without sacrificing capabilities).
 .
 Lilv is the successor to SLV2, rewritten to be significantly faster
 and have minimal dependencies.
 .
 This package provides the development files.

Package: liblilv-doc
Section: doc
Architecture: all
Depends: ${misc:Depends}
Description: library for simple use of LV2 plugins (documentation)
 Lilv (formerly SLV2) is a library for LV2 hosts intended to make using
 LV2 Plugins as simple as possible (without sacrificing capabilities).
 .
 Lilv is the successor to SLV2, rewritten to be significantly faster
 and have minimal dependencies.
 .
 This package provides the documentation files.

Package: lilv-utils
Section: sound
Architecture: any
Depends: ${shlibs:Depends},
 ${misc:Depends}
Provides: lv2-host
Description: library for simple use of LV2 plugins (runtime files)
 Lilv (formerly SLV2) is a library for LV2 hosts intended to make using
 LV2 Plugins as simple as possible (without sacrificing capabilities).
 .
 Lilv is the successor to SLV2, rewritten to be significantly faster
 and have minimal dependencies.
 .
 This package provides the following utilities:
  * lv2info - Extract information about an LV2 plugin.
  * lv2jack - Run an LV2 plugin as a JACK application.
  * lv2ls - List all installed LV2 plugins.

## lilv 0.4.4

=== wscript ===
--- 
+++ 
@@ -8,7 +8,7 @@
 import waflib.Logs as Logs
 
 # Version of this package (even if built as a child)
-LILV_VERSION       = '0.4.2'
+LILV_VERSION       = '0.4.4'
 LILV_MAJOR_VERSION = '0'
 
 # Library version (UNIX style major, minor, micro)
@@ -31,11 +31,6 @@
     opt.load('python')
     opt.add_option('--no-utils', action='store_true', default=False, dest='no_utils',
                    help="Do not build command line utilities")
-    opt.add_option('--no-jack', action='store_true', default=False, dest='no_jack',
-                   help="Do not build JACK clients")
-    opt.add_option('--no-jack-session', action='store_true', default=False,
-                   dest='no_jack_session',
-                   help="Do not build JACK session support")
     opt.add_option('--bindings', action='store_true', default=False, dest='bindings',
                    help="Build python bindings")
     opt.add_option('--dyn-manifest', action='store_true', default=False,
@@ -61,7 +56,7 @@
         try:
             conf.load('swig python')
             conf.check_python_headers()
-            autowaf.define(conf, 'LILV_BINDINGS', 1);
+            autowaf.define(conf, 'LILV_PYTHON', 1);
         except:
             pass
 
@@ -72,10 +67,6 @@
                       atleast_version='2.0.0', mandatory=False)
     autowaf.check_pkg(conf, 'sord-0', uselib_store='SORD',
                       atleast_version='0.4.0', mandatory=True)
-    autowaf.check_pkg(conf, 'jack', uselib_store='JACK',
-                      atleast_version='0.107.0', mandatory=False)
-    autowaf.check_pkg(conf, 'jack', uselib_store='NEW_JACK',
-                      atleast_version='0.120.0', mandatory=False)
 
     conf.check(function_name='wordexp',
                header_name='wordexp.h',
@@ -83,10 +74,6 @@
                mandatory=False)
 
     autowaf.check_header(conf, 'lv2/lv2plug.in/ns/lv2core/lv2.h')
-
-    if not Options.options.no_jack_session:
-        if conf.is_defined('HAVE_NEW_JACK') and conf.is_defined('HAVE_GTHREAD'):
-            autowaf.define(conf, 'LILV_JACK_SESSION', 1)
 
     conf.env.append_value('CFLAGS', '-std=c99')
     autowaf.define(conf, 'LILV_VERSION', LILV_VERSION)
@@ -131,28 +118,12 @@
 
     conf.env['LIB_LILV'] = ['lilv-%s' % LILV_MAJOR_VERSION]
 
-    if conf.is_defined('HAVE_JACK') and not Options.options.no_jack:
-        autowaf.check_header(conf, 'lv2/lv2plug.in/ns/ext/event/event.h',
-                             'HAVE_LV2_EVENT', mandatory=False)
-        autowaf.check_header(conf, 'lv2/lv2plug.in/ns/ext/event/event-helpers.h',
-                             'HAVE_LV2_EVENT_HELPERS', mandatory=False)
-        autowaf.check_header(conf, 'lv2/lv2plug.in/ns/ext/uri-map/uri-map.h',
-                             'HAVE_LV2_URI_MAP', mandatory=False)
-        if (conf.is_defined('HAVE_LV2_EVENT')
-            and conf.is_defined('HAVE_LV2_EVENT_HELPERS')
-            and conf.is_defined('HAVE_LV2_URI_MAP')):
-            autowaf.define(conf, 'LILV_USE_JACK', 1)
-
     conf.write_config_header('lilv-config.h', remove=False)
 
     autowaf.display_msg(conf, "Default LV2_PATH",
                         conf.env['LILV_DEFAULT_LV2_PATH'])
     autowaf.display_msg(conf, "Utilities",
                         bool(conf.env['BUILD_UTILS']))
-    autowaf.display_msg(conf, "Jack clients",
-                        bool(conf.is_defined('LILV_USE_JACK')))
-    autowaf.display_msg(conf, "Jack session support",
-                        bool(conf.env['LILV_JACK_SESSION']))
     autowaf.display_msg(conf, "Unit tests",
                         bool(conf.env['BUILD_TESTS']))
     autowaf.display_msg(conf, "Dynamic manifest support",
@@ -244,18 +215,6 @@
                       target       = i,
                       install_path = '${BINDIR}')
 
-    # JACK Host
-    if bld.is_defined('LILV_USE_JACK'):
-        obj = bld(features     = 'c cprogram',
-                  source       = 'utils/lv2jack.c',
-                  includes     = ['.', './src', './utils'],
-                  uselib       = 'JACK',
-                  use          = 'liblilv',
-                  target       = 'utils/lv2jack',
-                  install_path = '${BINDIR}')
-        if bld.is_defined('LILV_JACK_SESSION'):
-            autowaf.use_lib(bld, obj, 'GLIB GTHREAD')
-
     # Documentation
     autowaf.build_dox(bld, 'LILV', LILV_VERSION, top, out)
 
@@ -274,7 +233,6 @@
                   target     = 'bindings/_lilv',
                   includes   = ['..'],
                   swig_flags = '-c++ -python -Wall -I.. -llilv -features autodoc=1',
-                  vnum       = LILV_LIB_VERSION,
                   use        = 'liblilv')
         autowaf.use_lib(bld, obj, 'LILV')
 
@@ -303,3 +261,16 @@
         os.chdir(build_dir(ctx, 'doc/man/man3'))
         os.system("sed -i 's/LILV_API //' lilv.3")
         os.chdir(top)
+    except:
+        Logs.error("Failed to fix up %s documentation" % APPNAME)
+
+def upload_docs(ctx):
+    os.system("rsync -ravz --delete -e ssh build/doc/html/ drobilla@drobilla.net:~/drobilla.net/docs/lilv/")
+
+def test(ctx):
+    autowaf.pre_test(ctx, APPNAME)
+    autowaf.run_tests(ctx, APPNAME, ['test/lilv_test'], dirs=['./src','./test'])
+    autowaf.post_test(ctx, APPNAME)
+
+def lint(ctx):
+    subprocess.call('cpplint.py --filter=+whitespace/comments,-whitespace/tab,-whitespace/braces,-whitespace/labels,-build/header_guard,-readability/casting,-readability/todo,-build/include src/* lilv/*', shell=True)

=== debian/changelog ===
lilv (0.4.4-2) unstable; urgency=low

  * Update description as lilv-utils does no longer provide lv2jack.
  * Add patch taken from upstream SVN to fix a memory leak.
  * Support all Python versions.

 -- Alessio Treglia <alessio@debian.org>  Fri, 24 Jun 2011 10:27:00 +0200

lilv (0.4.4-1) unstable; urgency=low

  * New upstream release.
  * Delete debian/patches/0001-fix_python_bindings_detection.patch,
    applied upstream.
  * Refresh remaining patches.

 -- Alessio Treglia <alessio@debian.org>  Sun, 12 Jun 2011 12:56:46 +0200

=== debian/control ===
--- 
+++ 
@@ -39,6 +39,7 @@
 Depends: ${shlibs:Depends},
  ${python:Depends},
  ${misc:Depends}
+Provides: ${python:Provides}
 Description: library for simple use of LV2 plugins (Python bindings)
  Lilv (formerly SLV2) is a library for LV2 hosts intended to make using
  LV2 Plugins as simple as possible (without sacrificing capabilities).
@@ -91,5 +92,4 @@
  .
  This package provides the following utilities:
   * lv2info - Extract information about an LV2 plugin.
-  * lv2jack - Run an LV2 plugin as a JACK application.
   * lv2ls - List all installed LV2 plugins.

## lilv 0.5.0

=== wscript ===
--- 
+++ 
@@ -8,7 +8,7 @@
 import waflib.Logs as Logs
 
 # Version of this package (even if built as a child)
-LILV_VERSION       = '0.4.4'
+LILV_VERSION       = '0.5.0'
 LILV_MAJOR_VERSION = '0'
 
 # Library version (UNIX style major, minor, micro)
@@ -27,8 +27,10 @@
 out = 'build'
 
 def options(opt):
+    opt.load('compiler_c')
+    opt.load('compiler_cxx')
+    opt.load('python')
     autowaf.set_options(opt)
-    opt.load('python')
     opt.add_option('--no-utils', action='store_true', default=False, dest='no_utils',
                    help="Do not build command line utilities")
     opt.add_option('--bindings', action='store_true', default=False, dest='bindings',
@@ -40,16 +42,16 @@
                    help="Build unit tests")
     opt.add_option('--no-bash-completion', action='store_true', default=False,
                    dest='no_bash_completion',
-                   help="Install bash completion script in /etc/bash_completion.d")
+                   help="Don't install bash completion script in CONFIGDIR")
     opt.add_option('--default-lv2-path', type='string', default='',
                    dest='default_lv2_path',
                    help="Default LV2 path to use if $LV2_PATH is unset (globs and ~ supported)")
+    opt.add_option('--static', action='store_true', default=False, dest='static',
+                   help="Build static library")
 
 def configure(conf):
-    conf.line_just = 63
-    autowaf.configure(conf)
-    autowaf.display_header('Lilv Configuration')
-    conf.load('compiler_cc')
+    conf.load('compiler_c')
+    conf.load('compiler_cxx')
     conf.load('python')
 
     if Options.options.bindings:
@@ -60,22 +62,22 @@
         except:
             pass
 
+    conf.line_just = 51
+    autowaf.configure(conf)
+    autowaf.display_header('Lilv Configuration')
+
     autowaf.check_pkg(conf, 'lv2core', uselib_store='LV2CORE', mandatory=True)
-    autowaf.check_pkg(conf, 'glib-2.0', uselib_store='GLIB',
-                      atleast_version='2.0.0', mandatory=True)
-    autowaf.check_pkg(conf, 'gthread-2.0', uselib_store='GTHREAD',
-                      atleast_version='2.0.0', mandatory=False)
     autowaf.check_pkg(conf, 'sord-0', uselib_store='SORD',
-                      atleast_version='0.4.0', mandatory=True)
+                      atleast_version='0.5.0', mandatory=True)
 
     conf.check(function_name='wordexp',
                header_name='wordexp.h',
                define_name='HAVE_WORDEXP',
                mandatory=False)
 
-    autowaf.check_header(conf, 'lv2/lv2plug.in/ns/lv2core/lv2.h')
-
-    conf.env.append_value('CFLAGS', '-std=c99')
+    autowaf.check_header(conf, 'c', 'lv2/lv2plug.in/ns/lv2core/lv2.h')
+
+    conf.env.append_unique('CFLAGS', '-std=c99')
     autowaf.define(conf, 'LILV_VERSION', LILV_VERSION)
     if Options.options.dyn_manifest:
         autowaf.define(conf, 'LILV_DYN_MANIFEST', 1)
@@ -114,6 +116,7 @@
 
     conf.env['BUILD_TESTS']     = Options.options.build_tests
     conf.env['BUILD_UTILS']     = not Options.options.no_utils
+    conf.env['BUILD_STATIC']    = Options.options.static
     conf.env['BASH_COMPLETION'] = not Options.options.no_bash_completion
 
     conf.env['LIB_LILV'] = ['lilv-%s' % LILV_MAJOR_VERSION]
@@ -154,6 +157,7 @@
         src/ui.c
         src/util.c
         src/world.c
+        src/zix/tree.c
     '''.split()
 
     linkflags = [ '-ldl' ]
@@ -162,7 +166,7 @@
         linkflags = []
         libflags  = []
 
-    # Library
+    # Shared Library
     obj = bld(features        = 'c cshlib',
               export_includes = ['.'],
               source          = lib_source,
@@ -171,34 +175,48 @@
               target          = 'lilv-%s' % LILV_MAJOR_VERSION,
               vnum            = LILV_LIB_VERSION,
               install_path    = '${LIBDIR}',
-              cflags          = libflags + [
-                                  '-DLILV_SHARED',
-                                  '-DLILV_INTERNAL' ],
+              cflags          = libflags + [ '-DLILV_SHARED',
+                                             '-DLILV_INTERNAL' ],
               linkflags       = linkflags)
-    autowaf.use_lib(bld, obj, 'SORD SERD LV2CORE GLIB')
+    autowaf.use_lib(bld, obj, 'SORD LV2CORE')
+
+    # Static library
+    if bld.env['BUILD_STATIC']:
+        obj = bld(features        = 'c cstlib',
+                  export_includes = ['.'],
+                  source          = lib_source,
+                  includes        = ['.', './src'],
+                  name            = 'liblilv_static',
+                  target          = 'lilv-%s' % LILV_MAJOR_VERSION,
+                  vnum            = LILV_LIB_VERSION,
+                  install_path    = '${LIBDIR}',
+                  cflags          = [ '-DLILV_INTERNAL' ])
+        autowaf.use_lib(bld, obj, 'SORD LV2CORE')
 
     if bld.env['BUILD_TESTS']:
-        # Static library (for unit test code coverage)
+        # Static profiled library (for unit test code coverage)
         obj = bld(features     = 'c cstlib',
                   source       = lib_source,
                   includes     = ['.', './src'],
-                  name         = 'liblilv_static',
-                  target       = 'lilv_static',
+                  name         = 'liblilv_profiled',
+                  target       = 'lilv_profiled',
                   install_path = '',
-                  cflags       = [ '-fprofile-arcs',  '-ftest-coverage', '-DLILV_INTERNAL' ],
-                  linkflags    = linkflags)
-        autowaf.use_lib(bld, obj, 'SORD SERD LV2CORE GLIB')
+                  cflags       = [ '-fprofile-arcs', '-ftest-coverage',
+                                   '-DLILV_INTERNAL' ],
+                  linkflags    = linkflags + ['-lgcov'])
+        autowaf.use_lib(bld, obj, 'SORD LV2CORE')
 
         # Unit test program
         obj = bld(features     = 'c cprogram',
                   source       = 'test/lilv_test.c',
                   includes     = ['.', './src'],
-                  use          = 'liblilv_static',
-                  uselib       = 'SORD SERD LV2CORE',
+                  use          = 'liblilv_profiled',
+                  uselib       = 'SORD LV2CORE',
                   linkflags    = linkflags + ['-lgcov'],
                   target       = 'test/lilv_test',
                   install_path = '',
                   cflags       = [ '-fprofile-arcs',  '-ftest-coverage' ])
+        autowaf.use_lib(bld, obj, 'SORD LV2CORE')
 
     # Utilities
     if bld.env['BUILD_UTILS']:
@@ -224,7 +242,7 @@
     # Bash completion
     if bld.env['BASH_COMPLETION']:
         bld.install_as(
-            '/etc/bash_completion.d/lilv', 'utils/lilv.bash_completion')
+            '${SYSCONFDIR}/bash_completion.d/lilv', 'utils/lilv.bash_completion')
 
     if bld.is_defined('LILV_PYTHON'):
         # Python Wrapper

=== debian/changelog ===
lilv (0.5.0-1) unstable; urgency=low

  * New upstream release:
    - Remove glib dependency
    - Add lv2core as a pkg-config dependency (for lv2.h header include)
    - Obey prefix when installing bash completion script
    - Support integer minimum, maximum, and default port values in
      lilv_plugin_get_port_ranges_float
    - Add ability to build static library
  * Requires sord >= 0.5.0.
  * Refresh patches.
  * Remove 0002-dyn_manifest_fix.patch, applied upstream.
  * Remove 2001-memleak.patch, applied upstream.
  * Drop libglib2.0-dev build-dependency.
  * Update symbols file.
  * Bash completion stuff are now installed in /usr/etc, so we need to
    move them from there to /etc.

 -- Alessio Treglia <alessio@debian.org>  Tue, 04 Oct 2011 17:51:37 +0200

=== debian/control ===
--- 
+++ 
@@ -4,9 +4,8 @@
 Maintainer: Debian Multimedia Maintainers <pkg-multimedia-maintainers@lists.alioth.debian.org>
 Uploaders: Alessio Treglia <alessio@debian.org>
 Build-Depends: debhelper (>= 7.0.50~),
- libglib2.0-dev,
  libjack-dev,
- libsord-dev,
+ libsord-dev (>= 0.5.0),
  lv2core,
  lv2-extensions-good,
  pkg-config,

=== debian/rules ===
#!/usr/bin/make -f

LDFLAGS+=-Wl,--as-needed
WAF = ./waf
PYVERS=$(shell pyversions -s)

ifeq ($(shell dpkg-query -s doxygen graphviz 1>/dev/null 2>&1 && echo yes),yes)
CONFIGURE_EXTRA_FLAGS += --docs
endif

%:
	dh $@ --with python2

override_dh_auto_configure:
override_dh_auto_build:
override_dh_auto_install:
	for pyver in $(PYVERS); do \
		PYTHON="$$pyver" $(WAF) configure \
				--prefix=/usr \
				--mandir=/usr/share/man \
				--strict \
				--debug \
				--bindings \
				--dyn-manifest \
				$(CONFIGURE_EXTRA_FLAGS) && \
		PYTHON="$$pyver" $(WAF) && \
		PYTHON="$$pyver" $(WAF) install -f --destdir=$(CURDIR)/debian/tmp ; \
	done

override_dh_auto_clean:
	$(WAF) distclean
	rm -rf build .waf*
	dh_auto_clean

## lilv 0.5.0+dfsg0

=== debian/changelog ===
lilv (0.5.0+dfsg0-1) unstable; urgency=low

  * Repack upstream tarball to get rid of the waf binary (Closes: #654485).
  * Adjust the clean target to properly clean the sources tree.

 -- Alessio Treglia <alessio@debian.org>  Tue, 10 Jan 2012 09:52:44 +0100

lilv (0.5.0-2) unstable; urgency=medium

  * Fix FTBFS with newest dynmanifest extension. (Closes: #654271)
  * Bump dependency on lv2-extensions-good.

 -- Alessio Treglia <alessio@debian.org>  Tue, 03 Jan 2012 02:14:57 +0100

=== debian/control ===
--- 
+++ 
@@ -7,7 +7,7 @@
  libjack-dev,
  libsord-dev (>= 0.5.0),
  lv2core,
- lv2-extensions-good,
+ lv2-extensions-good (>= 0~20111202-1~),
  pkg-config,
  python-all-dev (>= 2.6.6-3),
  swig

=== debian/rules ===
--- 
+++ 
@@ -28,6 +28,7 @@
 	done
 
 override_dh_auto_clean:
-	$(WAF) distclean
+	$(WAF) clean || true
+	find -name "*.pyc" -delete
 	rm -rf build .waf*
 	dh_auto_clean

=== debian/watch ===
version=3
http://download.drobilla.net/lilv-(.*)\.tar\.bz2

## lilv 0.14.2~dfsg0

=== wscript ===
#!/usr/bin/env python
import os
import sys
import subprocess

from waflib.extras import autowaf as autowaf
import waflib.Options as Options
import waflib.Logs as Logs

# Version of this package (even if built as a child)
LILV_VERSION       = '0.14.2'
LILV_MAJOR_VERSION = '0'

# Library version (UNIX style major, minor, micro)
# major increment <=> incompatible changes
# minor increment <=> compatible changes (additions)
# micro increment <=> no interface changes
# Lilv uses the same version number for both library and package
LILV_LIB_VERSION = LILV_VERSION

# Variables for 'waf dist'
APPNAME = 'lilv'
VERSION = LILV_VERSION

# Mandatory variables
top = '.'
out = 'build'

def options(opt):
    opt.load('compiler_c')
    opt.load('compiler_cxx')
    opt.load('python')
    autowaf.set_options(opt)
    opt.add_option('--no-utils', action='store_true', default=False, dest='no_utils',
                   help="Do not build command line utilities")
    opt.add_option('--bindings', action='store_true', default=False, dest='bindings',
                   help="Build python bindings")
    opt.add_option('--dyn-manifest', action='store_true', default=False,
                   dest='dyn_manifest',
                   help="Build support for dynamic manifests")
    opt.add_option('--test', action='store_true', default=False, dest='build_tests',
                   help="Build unit tests")
    opt.add_option('--no-bash-completion', action='store_true', default=False,
                   dest='no_bash_completion',
                   help="Don't install bash completion script in CONFIGDIR")
    opt.add_option('--default-lv2-path', type='string', default='',
                   dest='default_lv2_path',
                   help="Default LV2 path to use if $LV2_PATH is unset (globs and ~ supported)")
    opt.add_option('--static', action='store_true', default=False, dest='static',
                   help="Build static library")

def configure(conf):
    conf.load('compiler_c')
    conf.load('compiler_cxx')
    conf.load('python')

    if Options.options.bindings:
        try:
            conf.load('swig python')
            conf.check_python_headers()
            autowaf.define(conf, 'LILV_PYTHON', 1);
        except:
            pass

    conf.line_just = 51
    autowaf.configure(conf)
    autowaf.display_header('Lilv Configuration')

    if conf.env['MSVC_COMPILER']:
        conf.env.append_unique('CFLAGS', ['-TP', '-MD'])
    else:
        conf.env.append_unique('CFLAGS', '-std=c99')

    conf.env['BUILD_TESTS']     = Options.options.build_tests
    conf.env['BUILD_UTILS']     = not Options.options.no_utils
    conf.env['BUILD_STATIC']    = Options.options.static
    conf.env['BASH_COMPLETION'] = not Options.options.no_bash_completion

    autowaf.check_pkg(conf, 'lv2', uselib_store='LV2',
                      atleast_version='1.0.0', mandatory=True)
    autowaf.check_pkg(conf, 'serd-0', uselib_store='SERD',
                      atleast_version='0.14.0', mandatory=True)
    autowaf.check_pkg(conf, 'sord-0', uselib_store='SORD',
                      atleast_version='0.8.0', mandatory=True)
    autowaf.check_pkg(conf, 'sratom-0', uselib_store='SRATOM',
                      atleast_version='0.2.0', mandatory=True)

    autowaf.define(conf, 'LILV_NEW_LV2', 1)  # New LV2 discovery API

    defines = ['_POSIX_C_SOURCE', '_BSD_SOURCE']
    if Options.platform == 'darwin':
        defines += ['_DARWIN_C_SOURCE']

    # Check for gcov library (for test coverage)
    if conf.env['BUILD_TESTS']:
        conf.check_cc(lib='gcov',
                      define_name='HAVE_GCOV',
                      mandatory=False)

    conf.check_cc(function_name='flock',
                  header_name='sys/file.h',
                  defines=defines,
                  define_name='HAVE_FLOCK',
                  mandatory=False)

    conf.check_cc(function_name='fileno',
                  header_name='stdio.h',
                  defines=defines,
                  define_name='HAVE_FILENO',
                  mandatory=False)

    autowaf.define(conf, 'LILV_VERSION', LILV_VERSION)
    if Options.options.dyn_manifest:
        autowaf.define(conf, 'LILV_DYN_MANIFEST', 1)

    lilv_path_sep = ':'
    lilv_dir_sep  = '/'
    if sys.platform == 'win32':
        lilv_path_sep = ';'
        lilv_dir_sep = '\\\\'

    autowaf.define(conf, 'LILV_PATH_SEP', lilv_path_sep)
    autowaf.define(conf, 'LILV_DIR_SEP',  lilv_dir_sep)

    # Set default LV2 path
    lv2_path = Options.options.default_lv2_path
    if lv2_path == '':
        if Options.platform == 'darwin':
            lv2_path = lilv_path_sep.join(['~/Library/Audio/Plug-Ins/LV2',
                                           '~/.lv2',
                                           '/usr/local/lib/lv2',
                                           '/usr/lib/lv2',
                                           '/Library/Audio/Plug-Ins/LV2'])
        elif Options.platform == 'haiku':
            lv2_path = lilv_path_sep.join(['~/.lv2',
                                           '/boot/common/add-ons/lv2'])
        elif Options.platform == 'win32':
            lv2_path = lilv_path_sep.join(['%APPDATA%\\\\LV2',
                                           '%COMMONPROGRAMFILES%\\\\LV2'])
        else:
            libdirname = os.path.basename(conf.env['LIBDIR'])
            lv2_path = lilv_path_sep.join(['~/.lv2',
                                           '/usr/%s/lv2' % libdirname,
                                           '/usr/local/%s/lv2' % libdirname])
    autowaf.define(conf, 'LILV_DEFAULT_LV2_PATH', lv2_path)

    conf.env['LIB_LILV'] = ['lilv-%s' % LILV_MAJOR_VERSION]

    conf.write_config_header('lilv_config.h', remove=False)

    autowaf.display_msg(conf, "Default LV2_PATH",
                        conf.env['LILV_DEFAULT_LV2_PATH'])
    autowaf.display_msg(conf, "Utilities",
                        bool(conf.env['BUILD_UTILS']))
    autowaf.display_msg(conf, "Unit tests",
                        bool(conf.env['BUILD_TESTS']))
    autowaf.display_msg(conf, "Dynamic manifest support",
                        bool(conf.env['LILV_DYN_MANIFEST']))
    autowaf.display_msg(conf, "Python bindings",
                        conf.is_defined('LILV_PYTHON'))

    conf.undefine('LILV_DEFAULT_LV2_PATH')  # Cmd line errors with VC++
    print('')

def build(bld):
    # C/C++ Headers
    includedir = '${INCLUDEDIR}/lilv-%s/lilv' % LILV_MAJOR_VERSION
    bld.install_files(includedir, bld.path.ant_glob('lilv/*.h'))
    bld.install_files(includedir, bld.path.ant_glob('lilv/*.hpp'))

    # Pkgconfig file
    autowaf.build_pc(bld, 'LILV', LILV_VERSION, LILV_MAJOR_VERSION, [],
                     {'LILV_MAJOR_VERSION' : LILV_MAJOR_VERSION,
                      'LILV_PKG_DEPS'      : 'lv2 serd-0 sord-0 sratom-0'})

    lib_source = '''
        src/collections.c
        src/instance.c
        src/lib.c
        src/node.c
        src/plugin.c
        src/pluginclass.c
        src/port.c
        src/query.c
        src/scalepoint.c
        src/state.c
        src/ui.c
        src/util.c
        src/world.c
        src/zix/tree.c
    '''.split()

    lib      = ['dl']
    libflags = ['-fvisibility=hidden']
    defines  = []
    if sys.platform == 'win32':
        lib = []
    if bld.env['MSVC_COMPILER']:
        libflags = []
        defines  = ['snprintf=_snprintf']
    elif sys.platform.find('bsd') > 0:
        lib = []

    # Shared Library
    obj = bld(features        = 'c cshlib',
              export_includes = ['.'],
              source          = lib_source,
              includes        = ['.', './src'],
              name            = 'liblilv',
              target          = 'lilv-%s' % LILV_MAJOR_VERSION,
              vnum            = LILV_LIB_VERSION,
              install_path    = '${LIBDIR}',
              defines         = defines,
              cflags          = libflags + [ '-DLILV_SHARED',
                                             '-DLILV_INTERNAL' ],
              lib             = lib)
    autowaf.use_lib(bld, obj, 'SORD SRATOM LV2')

    # Static library
    if bld.env['BUILD_STATIC']:
        obj = bld(features        = 'c cstlib',
                  export_includes = ['.'],
                  source          = lib_source,
                  includes        = ['.', './src'],
                  name            = 'liblilv_static',
                  target          = 'lilv-%s' % LILV_MAJOR_VERSION,
                  vnum            = LILV_LIB_VERSION,
                  install_path    = '${LIBDIR}',
                  defines         = defines,
                  cflags          = [ '-DLILV_INTERNAL' ])
        autowaf.use_lib(bld, obj, 'SORD SRATOM LV2')

    if bld.env['BUILD_TESTS']:
        test_libs   = lib
        test_cflags = ['']
        if bld.is_defined('HAVE_GCOV'):
            test_libs   += ['gcov']
            test_cflags += ['-fprofile-arcs', '-ftest-coverage']

        # Test plugin library
        penv          = bld.env.derive()
        shlib_pattern = penv['cshlib_PATTERN']
        if shlib_pattern.startswith('lib'):
            shlib_pattern = shlib_pattern[3:]
        penv['cshlib_PATTERN']   = shlib_pattern
        shlib_ext = shlib_pattern[shlib_pattern.rfind('.'):]

        obj = bld(features     = 'c cshlib',
                  env          = penv,
                  source       = 'test/test_plugin.c',
                  name         = 'test_plugin',
                  target       = 'test/test_plugin.lv2/test_plugin',
                  install_path = None,
                  defines      = defines,
                  cflags       = test_cflags,
                  lib          = test_libs,
                  uselib       = 'LV2')

        # Test plugin data files
        for i in [ 'manifest.ttl.in', 'test_plugin.ttl.in' ]:
            bld(features     = 'subst',
                source       = 'test/' + i,
                target       = 'test/test_plugin.lv2/' + i.replace('.in', ''),
                install_path = None,
                SHLIB_EXT    = shlib_ext)

        # Static profiled library (for unit test code coverage)
        obj = bld(features     = 'c cstlib',
                  source       = lib_source,
                  includes     = ['.', './src'],
                  name         = 'liblilv_profiled',
                  target       = 'lilv_profiled',
                  install_path = None,
                  defines      = defines,
                  cflags       = test_cflags + ['-DLILV_INTERNAL'],
                  lib          = test_libs)
        autowaf.use_lib(bld, obj, 'SORD SRATOM LV2')

        # Unit test program
        bpath = os.path.abspath(os.path.join(out, 'test', 'test_plugin.lv2'))
        bpath = bpath.replace('\\', '/')
        obj = bld(features     = 'c cprogram',
                  source       = 'test/lilv_test.c',
                  includes     = ['.', './src'],
                  use          = 'liblilv_profiled',
                  uselib       = 'SORD LV2',
                  lib          = test_libs,
                  target       = 'test/lilv_test',
                  install_path = None,
                  defines      = defines + ['LILV_TEST_BUNDLE=\"%s/\"' % bpath],
                  cflags       = test_cflags)
        autowaf.use_lib(bld, obj, 'SORD SRATOM LV2')

    # Utilities
    if bld.env['BUILD_UTILS']:
        utils = '''
            utils/lv2info
            utils/lv2ls
            utils/lilv-bench
        '''
        for i in utils.split():
            obj = bld(features     = 'c cprogram',
                      source       = i + '.c',
                      includes     = ['.', './src', './utils'],
                      use          = 'liblilv',
                      target       = i,
                      defines      = defines,
                      install_path = '${BINDIR}')

    # Documentation
    autowaf.build_dox(bld, 'LILV', LILV_VERSION, top, out)

    # Man pages

=== debian/changelog ===
lilv (0.14.2~dfsg0-4) unstable; urgency=low

  * Attempt to fix FTBFS on non-Linux architectures.
    Thanks to Steven Chamberlain for the patch.
  * Fix Vcs tags.

 -- Alessio Treglia <alessio@debian.org>  Thu, 14 Jun 2012 23:25:40 +0200

lilv (0.14.2~dfsg0-3) unstable; urgency=low

  * Add libs{{e,o}rd,ratom}-dev into liblilv-dev's Depends field.
    (Closes: #674505)

 -- Alessio Treglia <alessio@debian.org>  Fri, 25 May 2012 09:38:05 +0200

lilv (0.14.2~dfsg0-2) unstable; urgency=low

  * liblilv-dev depends on lv2-dev instead of lv2core.
  * Save some space by removing liblilv-doc, the same documentation
    is available online at: http://drobilla.net/docs/lilv/

 -- Alessio Treglia <alessio@debian.org>  Mon, 21 May 2012 11:31:46 +0200

lilv (0.14.2~dfsg0-1) unstable; urgency=low

  * New upstream release (Closes: #670647).
  * Replace old LV2 build-deps with lv2-dev.
  * Add build-dependency on libsratom-dev.
  * Add build-dep on libserd-dev, tighten up libsord-dev build-dependency.
  * Remove 0001-new_dynmanifest.patch, no longer needed.
  * Refresh all patches.
  * Switch -DEV to Arch: any.
  * Update symbols.
  * Update debian/copyright.
  * Bump debhelper requirement to 9.
  * debian/watch: Mangle dfsg suffix.
  * Bump Standards-Version.

 -- Alessio Treglia <alessio@debian.org>  Sun, 20 May 2012 23:48:54 +0200

=== debian/rules ===
--- 
+++ 
@@ -3,10 +3,6 @@
 LDFLAGS+=-Wl,--as-needed
 WAF = ./waf
 PYVERS=$(shell pyversions -s)
-
-ifeq ($(shell dpkg-query -s doxygen graphviz 1>/dev/null 2>&1 && echo yes),yes)
-CONFIGURE_EXTRA_FLAGS += --docs
-endif
 
 %:
 	dh $@ --with python2
@@ -21,8 +17,7 @@
 				--strict \
 				--debug \
 				--bindings \
-				--dyn-manifest \
-				$(CONFIGURE_EXTRA_FLAGS) && \
+				--dyn-manifest && \
 		PYTHON="$$pyver" $(WAF) && \
 		PYTHON="$$pyver" $(WAF) install -f --destdir=$(CURDIR)/debian/tmp ; \
 	done
